From ccd9dc60489f376b33c95227bb08c7b9ed18d5af Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 8/32] Issues: Add links to view more


---

diff --git a/hubs/static/client/app/widgets/issues/Widget.js b/hubs/static/client/app/widgets/issues/Widget.js
index 1a98c7b..7e7ba26 100644
--- a/hubs/static/client/app/widgets/issues/Widget.js
+++ b/hubs/static/client/app/widgets/issues/Widget.js
@@ -14,8 +14,8 @@ export default class IssuesWidget extends React.PureComponent {
     super(props);
     this.state = {
       issues: [],
-      counts: {},
-      isLoading: false
+      more: {},
+      isLoading: true
     }
   }
 
@@ -46,7 +46,7 @@ export default class IssuesWidget extends React.PureComponent {
       success: (res) => {
         this.setState({
             issues: res.data.issues,
-            counts: res.data.counts,
+            more: res.data.more,
             isLoading: false
           },
           () => (
@@ -67,63 +67,70 @@ export default class IssuesWidget extends React.PureComponent {
         widget={this.props.widget}
         editMode={this.props.editMode}
       >
-        <ul className="list-unstyled">
-          { this.state.isLoading && <Spinner className="p-3"/>}
-          {
-            this.state.issues.map((issue) => {
-              return (
-                <li key={issue.service + issue.number} className="py-2">
-                  <div className="row">
-                    <div className="col-md-6">
-                      <a  href={ issue.url }
-                          target="_blank" rel="noopener noreferrer">
-                        <span className="badge badge-primary">#{ issue.number }</span>
-                      </a>
+        { this.state.isLoading && <Spinner className="p-3"/>}
+        { !this.state.isLoading &&
+        <div>
+          <ul className="list-unstyled">
+            {
+              this.state.issues.map((issue) => {
+                return (
+                  <li key={issue.service + issue.number} className="py-2">
+                    <div className="row">
+                      <div className="col-md-6">
+                        <a  href={ issue.url }
+                            target="_blank" rel="noopener noreferrer">
+                          <span className="badge badge-primary">#{ issue.number }</span>
+                        </a>
+                      </div>
+                      <div className="col-md-6">
+                        <div className="float-right">
+                          <span>{ issue.project }</span>
+                          <img src={ issue.icon } style={{height: '16px'}} className={"ml-2"}/>
+                        </div>
+                      </div>
                     </div>
-                    <div className="col-md-6">
-                      <div className="float-right">
-                        <span>{ issue.project }</span>
-                        <img src={ issue.icon } style={{height: '16px'}} className={"ml-2"}/>
+                    <div className="row">
+                      <div className="col-12">
+                        <span>{ issue.title }</span>
                       </div>
                     </div>
+                  </li>
+                )
+              })
+            }
+          </ul>
+          <div className="card-footer p-1">
+            <div className="row p-1">
+              <div className="col-md-3 text-muted"
+                   data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}
+              >
+                <span>View More</span>
+                <i className="fa fa-angle-right ml-1" aria-hidden="true" />
+              </div>
+              <div className="col-md-9 collapse" id={'counts'}>
+                <div className="row pt-0">
+                  <div className="col-md-4 text-center">
+                    <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                    <a target="blank"
+                       href={ this.state.more.bugzilla.link }>Bugzilla ({ this.state.more.bugzilla.count })</a>
                   </div>
-                  <div className="row">
-                    <div className="col-12">
-                      <span>{ issue.title }</span>
-                    </div>
+                  <div className="col-md-4 text-center">
+                    <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                    <a target="blank"
+                       href={ this.state.more.github.link }>Github ({ this.state.more.github.count })</a>
+                  </div>
+                  <div className="col-md-4 text-center">
+                    <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
+                    <a target="blank"
+                       href={ this.state.more.pagure.link }>Pagure ({ this.state.more.pagure.count })</a>
                   </div>
-                </li>
-              )
-            })
-          }
-        </ul>
-        <div className="card-footer p-1">
-          <div className="row p-1">
-            <div className="col-md-3 text-muted"
-                 data-toggle="collapse" data-target="#counts" style={{cursor: 'pointer'}}
-            >
-              <span>View More</span>
-              <i className="fa fa-angle-right ml-1" aria-hidden="true" />
-            </div>
-            <div className="col-md-9 collapse" id={'counts'}>
-              <div className="row pt-0">
-                <div className="col-md-4 text-center">
-                  <img src="https://bugzilla.redhat.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                  <span>Bugzilla ({ this.state.counts.bugzilla })</span>
-                </div>
-                <div className="col-md-4 text-center">
-                  <img src="https://github.com/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                  <span>Github ({ this.state.counts.github })</span>
-                </div>
-                <div className="col-md-4 text-center">
-                  <img src="https://pagure.io/static/favicon.ico" style={{height: '16px'}} className={"mr-2"}/>
-                  <span>Pagure ({ this.state.counts.pagure })</span>
                 </div>
-              </div>
 
+              </div>
             </div>
           </div>
         </div>
+        }
       </WidgetChrome>
     )
   }
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index b3e8c62..a14a7c5 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -52,5 +52,16 @@ class DataView(WidgetView):
         all_issues = bugzilla + pagure + github
         all_issues.sort(key=lambda x: arrow.get(x['updated_at']), reverse=True)
 
-        data = {'issues': all_issues, 'counts': {'bugzilla': bzcnt, 'pagure': pcnt, 'github': ghcnt}}
+        data = {
+            'issues': all_issues,
+            'more': {
+                'bugzilla': {'count': bzcnt, 'link': '#'},
+                'pagure': {'count': pcnt,
+                           'link': 'https://pagure.io/user/{}/issues'.format(instance.hub.config['pagure_username'])},
+                'github': {'count': ghcnt,
+                           'link': 'https://github.com/issues?q=type:issue+state:open+{}:{}'
+                                    .format(instance.config['mode'], instance.hub.config['github_username'])
+                           }
+            }
+        }
         return dict(status='OK', data=data)

